<template>
  <div>
    <p v-if="loadingList" class="loadingErrorSection">Cargando...</p>
    <div v-else-if="errorList" class="noListContainer">
      <p class="loadingErrorSection">Error... No hay elementos para mostrar, intente mas tarde!</p>
      <img
        class="noListImage"
        alt="Vue logo"
        src="@/assets/no-list.jpg"
        width="500px"
        height="500px"
        @click="toggleSound()"
      />
    </div>

    <div v-else class="wrapperList">
      <div v-for="(x, index) in dataList" v-bind:key="x.name">
        <div
          :class="x.isOpen ? 'selectedItem' : 'itemContainer'"
          @click="handleOpenCard(x.url, index)"
        >
          <h1>{{ x.name }}</h1>
          <div class="imageWrapper">
            <img
              alt="Vue logo"
              class="logo arrowImage"
              src="@/assets/arrow_down.svg"
              width="30"
              height="30"
            />
          </div>
        </div>
        <p v-if="loadingCard && x.isOpen" class="loadingErrorSection">Cargando...</p>
        <div v-if="x.isOpen">
          <div class="wrapperCard hiddenDiv">
            <div class="numberSec">
              <h2>#</h2>
              <div>
                {{ { ...dataCard }.id }}
              </div>
              <img
                alt="Vue logo"
                class="logo arrowImage"
                :src="{ ...dataCard }.sprites.front_default"
                width="150"
                height="150"
              />
              <div class="music-player">
                <audio ref="audio" :src="{ ...dataCard }.cries.latest" preload id="audio"></audio>

                <img
                  alt="Vue logo"
                  class="playImage"
                  src="@/assets/play.svg"
                  width="50"
                  height="50"
                  @click="toggleSound()"
                />
              </div>
            </div>
            <div class="abilities">
              <h2>Abilities</h2>
              <div v-for="x in { ...dataCard }.abilities" v-bind:key="x.ability.name">
                {{ '- ' + x.ability.name }}
              </div>
            </div>
            <div class="abilities">
              <h2>Types</h2>
              <div v-for="x in { ...dataCard }.types" v-bind:key="x.type.name">
                {{ '- ' + x.type.name }}
              </div>
            </div>
            <div class="abilities">
              <p>{{ { ...dataCard }.base_experience }} EXP</p>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script setup>
import { ref, onMounted, toRaw } from 'vue'
import useFetch from '../composables/useFetch'

const dataList = ref(null)
const loadingList = ref(false)
const errorList = ref(null)
const dataCard = ref(null)
const loadingCard = ref(true)
const audio = ref(null)
const pagination = ref(null)

const toggleSound = async () => {
  ;[...audio.value][0].play()
}

const execPromiseList = async (url = null) => {
  const { data, error, loading } = await useFetch(url ? url : { ...pagination.value }.next)

  errorList.value = error
  loadingList.value = loading

  toRaw(data).results.forEach((element) => {
    element.isOpen = false
  })

  pagination.value = {
    count: { ...data }.count,
    next: { ...data }.next,
    previous: { ...data }.previous
  }

  dataList.value = url ? toRaw(data).results : [...dataList.value, ...data.results]
}

const handleOpenCard = async (url, index) => {
  toRaw(dataList.value).forEach((x) => (x.isOpen = false))

  if (!toRaw(dataList.value)[index].isOpen) {
    toRaw(dataList.value).forEach((x) => (x.isOpen = false))
    const { data } = await useFetch(url)
    toRaw(dataList.value)[index].isOpen = true

    dataCard.value = { ...data }
  }

  loadingCard.value = false
}

window.onscroll = () => {
  let bottomOfWindow =
    document.documentElement.scrollTop + window.innerHeight ===
    document.documentElement.offsetHeight
  if (bottomOfWindow) {
    execPromiseList()
  }
}

onMounted(() => execPromiseList(`${import.meta.env.VITE_API_ENDPOINT}?limit=20&offset=0`))
</script>

<style scoped>
.itemContainer {
  display: flex;
  justify-content: space-between;
  align-items: center;
  background-color: #80808014;
  border-radius: 15px;
  color: rgba(255, 255, 255, 0.733);
  padding: 8px 55px 8px 55px;
  position: relative;
  z-index: 2;
}

.selectedItem {
  display: flex;
  justify-content: space-between;
  align-items: center;
  background-color: #80808014;
  border-radius: 15px;
  position: relative;
  z-index: 2;
  color: rgba(255, 255, 255, 0.733);
  padding: 8px 55px 8px 55px;
  border: 2px solid #cc1417;
}

.itemContainer:hover {
  border: 2px solid #cc1417;
}
.wrapperList {
  display: grid;
  gap: 13px;
  overflow: auto;
  padding: 0 21px 0 0;
}

.arrowImage {
  fill: currentColor;
  color: red;
}
.imageWrapper {
  border: 1px solid red;
  background-color: rgba(255, 255, 255, 0.733);
  border-radius: 50%;
  display: grid;
  justify-content: center;
  align-items: center;
}

.abilities {
  display: grid;
  justify-content: center;
  align-self: stretch;
}

.wrapperCard {
  display: grid;
  grid-auto-flow: column;
  align-items: center;
  justify-content: space-evenly;
  position: relative;
  z-index: 0;
}

.numberSec {
  display: grid;
  grid-auto-flow: column;
  align-items: center;
  justify-content: center;
  gap: 8px;
}

.hiddenDiv {
  position: relative;
  bottom: 0;
  left: 50%;
  transform: translateX(-50%);
  background-color: #928e8e27;
  margin: 0px 55px 34px 0px;
  border-bottom-left-radius: 13px;
  border-bottom-right-radius: 13px;
  box-shadow: 0px 21px 0px 0px rgba(0, 0, 0, 0.2);
  animation: slideUp 0.5s ease forwards;
  z-index: 0;
  padding-bottom: 21px;
}

p {
  font-size: 34px;
  justify-self: center;
  align-self: center;
  color: rgba(255, 255, 255, 0.733);
  text-shadow:
    0 0 6px #dfdfdf,
    0 0 20px #ca0000;
  text-align: center;
}

.loadingErrorSection {
  font-size: 21px;
}

h1 {
  color: rgba(255, 255, 255, 0.733);
  text-shadow:
    0 0 0px #fbff00,
    0 0px 13px #1000ff;
}

.noListImage {
  justify-self: center;
  border-radius: 50%;
  border: 15px solid black;
  margin-top: 21px;
}

.noListContainer {
  display: grid;
  justify-content: center;
}

@media (max-width: 650px) {
  .wrapperCard {
    display: grid;
    grid-auto-flow: row;
    align-items: center;
    justify-content: center;
    gap: 21px;
  }

  .abilities {
    display: grid;
    justify-items: start;
    align-self: center;
  }

  .noListImage {
    width: 200px;
    height: 200px;
  }
}
</style>
